//
//  Benchmarker.h
//  Benchmarker
//
//  Created by Tom Bernard on Mon May 17 2004.
//  Copyright (c) 2004 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>

/*
    const double millisecondsMultiplier = 0.001;
    const double microsecondsMultiplier = 1.0;
    const double nanosecondsMultiplier = 1000.0;
    const double noResultsRequested = 0.0;
 
 */

@interface Benchmarker : NSObject 
{
    double          unitMultiplier, nanoseconds, microseconds, milliseconds;
    unsigned        samples, startBenchmarkIndex, endBenchmarkIndex, resultsReceivedCount;
    UInt32          accumulatedTime;
    BOOL            outputData, outputResults, disposeDataWhenDone, nsLogStampStartEnd;
    BOOL            firstPass, collectionNotComplete, dataDisposed;
    NSString        *unitsString, *userLabel;
    
    UnsignedWide    *startMicrosecondsArray, *endMicrosecondsArray;
    
        

}
- (id)initBenchmarkerForSamples:(unsigned)_samples 
                     outputData:(BOOL)_outputData 
                  outputResults:(BOOL)_outputResults 
             withUnitMultiplier:(double)_multiplier
            disposeDataWhenDone:(BOOL)_disposeDataWhenDone
             nsLogStampStartEnd:(BOOL)_nsLogStampStartEnd
                      userLabel:(NSString *)_userLabel;

- (void)disposeData;
- (void)startBenchmark;
- (void)endBenchmark;
#pragma mark -
- (unsigned)sampleTag;
- (void)endBenchmarkWithSampleTag:(unsigned)_tag;
#pragma mark -
- (void)tallyData;
- (void)doOutputResults;
- (void)resetBenchmarker;
#pragma mark -
- (double)nanosecondsDoubleValue;
- (float)nanosecondsFloatValue;
- (double)microsecondsDoubleValue;
- (float)microsecondsFloatValue;
- (double)millisecondsDoubleValue;
- (float)millisecondsFloatValue;
#pragma mark -
- (UnsignedWide *)startMicrosecondsArray;
- (UnsignedWide *)endMicrosecondsArray;
- (BOOL)getStartDatum:(UnsignedWide *)_microseconds atIdex:(unsigned)_index;
- (BOOL)getEndDatum:(UnsignedWide *)_microseconds atIdex:(unsigned)_index;
@end
