//
//  GLTFOpenGLView.h
//
//  gl_triangle_fan
//  Illusioner
//
//  Created by Tom Bernard on 10/1/06.
//  Copyright (c) 2006, Bersearch Information Services. All rights reserved.
//


#import <Cocoa/Cocoa.h>
#import <OpenGL/gl.h>

typedef enum _FirstPointType {		/* modes for setting the first point of a shape */
	zeroZero			= 0,
	originOrigin,
	randomFirstPoint,
	firstPointOnCircle
} FirstPointType;

@class Benchmarker;
@interface GLTFOpenGLView : NSOpenGLView
{
	BOOL inited, addedHueFactorMode;
	Benchmarker *drawRectBenchmark;
	long swap_enabled;
	float red, green, blue, rgbAlpha, hue, saturation, brightness, hsbAlpha, baseHue;
	GLfloat orthoXstart, orthoXend, orthoXdelta, lowerOrthoXdelta, upperOrthoXdelta, dOrthoXdelta;
	GLfloat orthoYstart, orthoYend, orthoYdelta, lowerOrthoYdelta, upperOrthoYdelta, dOrthoYdelta;
	GLfloat orthoZstart, orthoZend, orthoZdelta, sOrthoZdelta, eOrthoZdelta, dOrthoZdelta;
	float sides, dSides, sSides, eSides;
	float d_addedHueFactor, dd_addedHueFactor, upperD_addedHueFactor, lowerD_addedHueFactor;
	float pi, pi2;
	int firstPointMode;
}
- (void)delayedInit;
- (void)animate:(NSTimer *)timer;

- (void)renderCircleAsTriangleFanAtX:(float)originx
								   y:(float)originy
						  withRadius:(float)r
							andSides:(float)n;

- (void)renderColorfulShapeAtX:(float)originx 
							 y:(float)originy 
					withRadius:(float)r
						 sides:(float)n
						   hue:(float)_baseHue
					   andMode:(GLenum)mode;

- (void)doRandomFirstPointWithRadius:(GLfloat)r 
								 atX:(GLfloat)originx
								   y:(GLfloat)originy;

- (void)negateDOrthoXdelta;
- (void)negateDOrthoYdelta;
- (void)negateDOrthoZdelta;
- (void)calculateOrthoXYZStartEnd;
- (void)toggleAddedHueFactorMode;
- (void)incrementFirstPointMode;
@end
