/*
 void renderCircle(float originx, float originy, float r, float n)
 
 renderCircle renders a circle at originx, originy with a radius of r, 
 approximating the circle with n sides
 */

void renderCircleAsPolygon(float originx, float originy, float r, float n)
{
	float x, y, i, pi, pi2;
	
	pi = acos(-1.0);
	pi2 = 2 * pi;
	
	glBegin(GL_POLYGON);
	for (i = 0.0; i <= n; i++)
	{
		float theta = i * pi2 / n;
		x = r * cos(theta) + originx;
		y = r * sin(theta) + originy;
		glVertex3f(x, y, 0.0);
	}
	glEnd();
	
}


/*
void renderCircleAsTriangleFan(float originx, float originy, float r, float n)
{
	float x, y, i, pi, pi2;
	
	pi = acos(-1.0);
	pi2 = 2 * pi;
	
	glBegin(GL_TRIANGLE_FAN);
	for (i = 0.0; i <= n; i++)
	{
		float theta = i * pi2 / n;
		x = r * cos(theta) + originx;
		y = r * sin(theta) + originy;
		glVertex3f(x, y, 0.0);
	}
	glEnd();
	
}
 */

/*
void renderColorfulShape(float originx, float originy, float r, float n, float _baseHue, GLenum mode)
{
	float x, y, i, _hue, _adedHue, _red, _green, _blue, _rgbalpha;
	
	_adedHue = 0.0;
	float d_addedHue = 1.0 / n;
	
	glBegin(mode);
	for (i = 0.0; i <= n; i++)
	{
		float theta = i * pi2 / n;
		x = r * cos(theta) + originx;
		y = r * sin(theta) + originy;
		
		_hue = _baseHue + _adedHue;
		_adedHue += d_addedHue;
		if (_hue > 1.0) _hue -= 1.0;
		hsbaToRgba(_hue, 1.0, 1.0, 1.0, &_red, &_green, &_blue, &_rgbalpha);
			
		glColor4f(_red, _green, _blue, _rgbalpha);
		glVertex3f(x, y, 0.0);
	}
	glEnd();
	
}
 */

/*
- (id)initWithFrame:(NSRect)frame isPreview:(BOOL)isPreview
{
	self = [super initWithFrame:frame isPreview:isPreview];
	if (self)
	{
		animationTimeInterval = 1.0 / 60.0;
		[self setAnimationTimeInterval:animationTimeInterval];
		
		if (isPreview)
		{
			// printfNSRect("isPreview frame", frame);
			GLTFOpenGLView *gltfOpenGLView = [[[GLTFOpenGLView alloc] initWithFrame:NSMakeRect(0.0, 0.0, frame.size.width, frame.size.height)] autorelease];
			if (gltfOpenGLView) [self addSubview:gltfOpenGLView];
		}
		else
		{
			// [self initOpenGLViewForScreens:[NSScreen screens]];
			GLTFOpenGLView *gltfOpenGLView = [[[GLTFOpenGLView alloc] initWithFrame:NSMakeRect(0.0, 0.0, frame.size.width, frame.size.height)] autorelease];
			if (gltfOpenGLView) [self addSubview:gltfOpenGLView];
			
		}
	}
    return self;
}
 */

/*
- (id)initWithFrame:(NSRect)frame isPreview:(BOOL)isPreview
{
	self = [super initWithFrame:frame isPreview:isPreview];
	if (self) 
	{
		if (frame.origin.x + frame.origin.y)	// non-zero origin; do not create subview
		{
			[self setAnimationTimeInterval:10.0];
			printf("GLTFOpenGLView subview aborted for ");
		}
		else
		{
			
			// gltfOpenGLView = [[GLTFOpenGLView alloc] initWithFrame:frame];
			// [self addSubview:gltfOpenGLView];
			
			
			sAnimationRate = 1.0/120.0;
			eAnimationRate = 2.0;
			dAnimationRate = fabs(eAnimationRate - sAnimationRate) / 4.0;
			printf("dAnimationRate = %g\n", dAnimationRate);
			animationTimeInterval = sAnimationRate;
			
			[self initOpenGLViewForScreens:[NSScreen screens]];
			[self setAnimationTimeInterval:animationTimeInterval];
		}
		
		// printf("- [%s initWithFrame:isPreview:] ", [[self description] UTF8String]);
		// printfNSRect("frame", frame);
		
		
	}
	
	
    return self;
}
 */

/*
- (id)initWithFrame:(NSRect)frame isPreview:(BOOL)isPreview
{
	self = [super initWithFrame:frame isPreview:isPreview];
	if (self)
	{
		animationTimeInterval = 1.0 / 60.0;
		[self setAnimationTimeInterval:animationTimeInterval];
		
		if (isPreview)
		{
			// printfNSRect("isPreview frame", frame);
			GLTFOpenGLView *gltfOpenGLView = [[[GLTFOpenGLView alloc] initWithFrame:NSMakeRect(0.0, 0.0, frame.size.width, frame.size.height)] autorelease];
			if (gltfOpenGLView) [self addSubview:gltfOpenGLView];
		}
		else
		{
			// [self initOpenGLViewForScreens:[NSScreen screens]];
			GLTFOpenGLView *gltfOpenGLView = [[[GLTFOpenGLView alloc] initWithFrame:NSMakeRect(0.0, 0.0, frame.size.width, frame.size.height)] autorelease];
			if (gltfOpenGLView) [self addSubview:gltfOpenGLView];
			
		}
	}
    return self;
}
 */

/*
- (id)initWithFrame:(NSRect)frame isPreview:(BOOL)isPreview
{
	self = [super initWithFrame:frame isPreview:isPreview];
	if (self) 
	{
		if (frame.origin.x + frame.origin.y)	// non-zero origin; do not create subview
		{
			[self setAnimationTimeInterval:10.0];
			printf("GLTFOpenGLView subview aborted for ");
		}
		else
		{
			
			// gltfOpenGLView = [[GLTFOpenGLView alloc] initWithFrame:frame];
			// [self addSubview:gltfOpenGLView];
			
			
			sAnimationRate = 1.0/120.0;
			eAnimationRate = 2.0;
			dAnimationRate = fabs(eAnimationRate - sAnimationRate) / 4.0;
			printf("dAnimationRate = %g\n", dAnimationRate);
			animationTimeInterval = sAnimationRate;
			
			[self initOpenGLViewForScreens:[NSScreen screens]];
			[self setAnimationTimeInterval:animationTimeInterval];
		}
		
		// printf("- [%s initWithFrame:isPreview:] ", [[self description] UTF8String]);
		// printfNSRect("frame", frame);
		
		
	}
	
	
    return self;
}
 */

- (void)initOpenGLViewForScreens:(NSArray *)screens;


- (void)initOpenGLViewForScreens:(NSArray *)screens
{
	NSWindow *myWindow = [self window];
	// printfNSRect("myWindow frame", [myWindow frame]);
	// printf("%s\n", [[myWindow description] UTF8String]);
	
	NSScreen *screen;
	NSEnumerator *en = [screens objectEnumerator];
	while (screen = [en nextObject])
	{
		GLTFOpenGLView *gltfOpenGLView = [[[GLTFOpenGLView alloc] initWithFrame:[screen frame]] autorelease];
		if (gltfOpenGLView) [self addSubview:gltfOpenGLView];
	}
	// printf("subviews =%s\n", [[[self subviews] description] UTF8String]);
}



- (void)drawRect:(NSRect)rect
{
	// printf("-[%s drawRect:]\n", [[self description] UTF8String]);
	[benchmarker startBenchmark];
	
	if (!inited) [self delayedInit];
	
	glClear(GL_COLOR_BUFFER_BIT);
	
	glMatrixMode(GL_PROJECTION);
	
	glLoadIdentity();
	
	printf("ortho = %g\n", ortho);
	
	
	glOrtho(0.0, ortho, 0.0, ortho, 0.0, ortho);
	glMatrixMode(GL_MODELVIEW);
	
	
	// glColor4f(red, green, blue, rgbAlpha);
	float x, y;
	
	float addedHue = 0.0;
	
	
	/*
	// constant color using GL_POLYGON
	glColor4f(red, green, blue, rgbAlpha);
	for (x = 0.05; x < 1.0; x += 0.1)	
	{
		for (y = 0.05; y < 1.0; y += 0.1)
		{
			renderCircleAsPolygon(x, y, 0.05, 100.0);
		}
	}
	
	
	 */
	
	
	/*
	// constant color using GL_TRIANGLE_FAN
	glColor4f(red, green, blue, rgbAlpha);
	for (x = 0.05; x < 1.0; x += 0.1)	
	{
		for (y = 0.05; y < 1.0; y += 0.1)
		{
			renderCircleAsTriangleFan(x, y, 0.05, 100.0);
		}
	}
	 
	 */
	
	
	/*
	// simple color animation using GL_POLYGON
	hsbaToRgba(baseHue, saturation, brightness, hsbAlpha, &red, &green, &blue, &rgbAlpha);
	glColor4f(red, green, blue, rgbAlpha);
	for (x = 0.05; x < 1.0; x += 0.1)	
	{
		for (y = 0.05; y < 1.0; y += 0.1)
		{
			renderCircleAsPolygon(x, y, 0.05, 100.0);
		}
	}
	
	 */
	
	/*
	// simple color animation using GL_TRIANGLE_FAN
	hsbaToRgba(baseHue, saturation, brightness, hsbAlpha, &red, &green, &blue, &rgbAlpha);
	glColor4f(red, green, blue, rgbAlpha);
	for (x = 0.05; x < 1.0; x += 0.1)	
	{
		for (y = 0.05; y < 1.0; y += 0.1)
		{
			renderCircleAsTriangleFan(x, y, 0.05, 100.0);
		}
	}
	
	 */
	
	
	
	/*
	 // complex color animation using GL_POLYGON
	for (x = 0.05; x < 1.0; x += 0.1)	
	{
		for (y = 0.05; y < 1.0; y += 0.1)
		{
			 hue = baseHue + addedHue;
			 addedHue += 0.01;
			 if (hue > 1.0) hue -= 1.0;
			 hsbaToRgba(hue, saturation, brightness, hsbAlpha, &red, &green, &blue, &rgbAlpha);
			
			glColor4f(red, green, blue, rgbAlpha);
			renderCircleAsPolygon(x, y, 0.05, 100.0);
		}
	}
	 
	*/
	
	
	/*
	 // complex color animation using GL_TRIANGLE_FAN
	 for (x = 0.05; x < 1.0; x += 0.1)	
	 {
		 for (y = 0.05; y < 1.0; y += 0.1)
		 {
			 hue = baseHue + addedHue;
			 addedHue += 0.01;
			 if (hue > 1.0) hue -= 1.0;
			 hsbaToRgba(hue, saturation, brightness, hsbAlpha, &red, &green, &blue, &rgbAlpha);
			 
			 glColor4f(red, green, blue, rgbAlpha);
			 renderCircleAsTriangleFan(x, y, 0.05, 100.0);
		 }
	 }
	 */
	
	 
	 /*
	 // more complex color animation using GL_POLYGON
	 for (x = 0.05; x < 1.0; x += 0.1)	
	 {
		 for (y = 0.05; y < 1.0; y += 0.1)
		 {
			 hue = baseHue + addedHue;
			 addedHue += 0.01;
			 if (hue > 1.0) hue -= 1.0;
			 hsbaToRgba(hue, saturation, brightness, hsbAlpha, &red, &green, &blue, &rgbAlpha);
			 
			 glColor4f(red, green, blue, rgbAlpha);
			 renderCircleAsPolygon(x, y, 0.05, 100.0);
			 
			 renderColorfulShape(x, y, 0.04, 100.0, hue, GL_POLYGON);
		 }
	 }
	 
	  */
	 float workingSides, sidesShift = 0.0;

	 // more complex color animation using GL_TRIANGLE_FAN
	 for (x = 0.05; x < 1.0; x += 0.1)	
	 {
		 for (y = 0.05; y < 1.0; y += 0.1)
		 {
			 workingSides = sides + sidesShift;
			 if (workingSides > eSides) workingSides -= eSides;
			 
			 sidesShift += 2.0 * dSides;
			 if (sidesShift > (eSides - sSides)) sidesShift = 0.0;
			 
			 hue = baseHue + addedHue;
			 addedHue += 0.01;
			 if (hue > 1.0) hue -= 1.0;
			 hsbaToRgba(hue, saturation, brightness, hsbAlpha, &red, &green, &blue, &rgbAlpha);
			 
			 glColor4f(red, green, blue, rgbAlpha);
			 
			 // renderCircleAsTriangleFan(x, y, 0.05, 100.0);
			 
			 [self renderCircleAsTriangleFanAtX:x
											  y:y
									 withRadius:0.05
									   andSides:workingSides];
			 
			 // renderColorfulShape(x, y, 0.045, sides, hue, GL_TRIANGLE_FAN);
			 
			 [self renderColorfulShapeAtX:x 
										y:y 
							   withRadius:0.045
									sides:workingSides
									  hue:hue
								  andMode:GL_TRIANGLE_FAN];
		 }
	 }
	
    [[self openGLContext] flushBuffer];
	//  glutSwapBuffers();
	
	[benchmarker endBenchmark];
}